-- SLIDE 2/14 ------------------------------------------------------------------
ALTER USER ... IDENTIFIED BY ...

-- SLIDE 3/14 ------------------------------------------------------------------
create table STUDENT
(
  login char(6) primary key not null,
  jmeno varchar(30) not null,
  prijmeni varchar(50) not null
);

create table UCITEL
(
  login char(5) primary key not null,
  jmeno varchar(30) not null,
  prijmeni varchar(50) not null
);

create table KURZ
(
  kod char(11) primary key not null,
  nazev varchar(50)
);

create table STUDIJNIPLAN
(
  login char(6) not null,
  kod char(11) not null,
  rok smallint not null,
  primary key (login, kod, rok),
  foreign key (login) references STUDENT(login),
  foreign key (kod) references KURZ(kod)
);

create table GARANT
(
  login char(5) not null,
  kod char(11) not null,
  rok smallint not null,
  primary key (login, kod, rok),
  foreign key (login) references UCITEL(login),
  foreign key (kod) references KURZ(kod)
);

-- SLIDE 7/14 ------------------------------------------------------------------
insert into STUDENT values ('pla457', 'Jan', 'Plavek');
insert into STUDENT values ('sob458', 'Yveta', 'Sobotov');
insert into STUDENT values ('luk194', 'Petr', 'Luk');
insert into STUDENT values ('nov123', 'Jan', 'Novk');
insert into STUDENT values ('mla896', 'Karel', 'Mlad');

insert into KURZ values ('456-dais-01', 'Databzov a informan systmy');
insert into KURZ values ('456-tzd-01', 'Teorie zpracovn dat');
insert into KURZ values ('456-lait-01', 'Linern algebra pro IT');
insert into KURZ values ('456-udbs-01', 'vod do databzovch systm');
insert into KURZ values ('456-san-01', 'Softwarov inenrstv');

insert into UCITEL values ('bay01', 'Josef', 'Bayer');
insert into UCITEL values ('cod02', 'Stanislav', 'Codd');

insert into STUDIJNIPLAN values ('pla457', '456-dais-01', 2009);
insert into STUDIJNIPLAN values ('pla457', '456-tzd-01', 2009);
insert into STUDIJNIPLAN values ('pla457', '456-udbs-01', 2009);
insert into STUDIJNIPLAN values ('sob458', '456-san-01', 2009);
insert into STUDIJNIPLAN values ('sob458', '456-lait-01', 2009);
insert into STUDIJNIPLAN values ('sob458', '456-udbs-01', 2009);
insert into STUDIJNIPLAN values ('luk194', '456-dais-01', 2009);
insert into STUDIJNIPLAN values ('luk194', '456-tzd-01', 2009);
insert into STUDIJNIPLAN values ('luk194', '456-lait-01', 2009);
insert into STUDIJNIPLAN values ('nov123', '456-dais-01', 2009);
insert into STUDIJNIPLAN values ('nov123', '456-tzd-01', 2009);
insert into STUDIJNIPLAN values ('nov123', '456-san-01', 2009);
insert into STUDIJNIPLAN values ('mla896', '456-dais-01', 2009);
insert into STUDIJNIPLAN values ('mla896', '456-san-01', 2009);
insert into STUDIJNIPLAN values ('mla896', '456-udbs-01', 2009);

insert into GARANT values ('bay01', '456-dais-01', 2009);
insert into GARANT values ('bay01', '456-tzd-01', 2009);
insert into GARANT values ('cod02', '456-udbs-01', 2009);
insert into GARANT values ('cod02', '456-dais-01', 2009);


-- SLIDE 8/14 ------------------------------------------------------------------
-- select 1
select distinct
  student.*
from
  ucitel
  join garant on ucitel.login = garant.login and garant.rok = 2009
  join studijniplan on studijniplan.kod = garant.kod
  join student on studijniplan.login = student.login
where
  ucitel.prijmeni = 'Codd';
  
-- select 2
select
  kurz.*
from
  student
  join studijniplan on student.login = studijniplan.login
    and studijniplan.rok = 2009
  join kurz on studijniplan.kod = kurz.kod
where
  student.prijmeni = 'Plavek';

-- select 3
select
  kurz.*
from
  student
  join studijniplan on student.login = studijniplan.login
  join kurz on studijniplan.kod = kurz.kod
where
  student.prijmeni = 'Plavek';

-- Select 4
select distinct
  kod
from
  studijniplan
where
  rok = 2009;
  
-- Select 5
select distinct
  ucitel.*
from
  ucitel
  join garant on ucitel.login = garant.login and garant.rok = 2009
  join studijniplan on studijniplan.kod = garant.kod and studijniplan.rok = 2009

-- SLIDE 9/14 ------------------------------------------------------------------
-- Alter 1  
alter table ucitel add pracPomerZacatek date null;
alter table ucitel add pracPomerKonec date null;

-- Update 1
update ucitel
set
  pracPomerZacatek = TO_DATE('2008-01-01', 'yyyy-MM-dd'),
  pracPomerKonec =  TO_DATE('2008-01-01', 'yyyy-MM-dd')
where login = 'cod02';

-- Update 2
update ucitel
set
  pracPomerZacatek = TO_DATE('2008-01-01', 'yyyy-MM-dd'),
  pracPomerKonec =  TO_DATE('2010-01-01', 'yyyy-MM-dd')
where login = 'cod02';

update ucitel
set
  pracPomerZacatek = TO_DATE('2008-01-01', 'yyyy-MM-dd'),
  pracPomerKonec =  TO_DATE('2013-01-01', 'yyyy-MM-dd')
where login = 'bay01';

select distinct
  *
from
  ucitel
where
  pracPomerKonec - pracPomerZacatek > 3*365;
  
-- SLIDE 10/14 -----------------------------------------------------------------
grant select on student to pis0039;
revoke select on student from pis0039;

-- SLIDE 11/14 -----------------------------------------------------------------
select * from user_tab_columns where table_name = 'STUDENT';
desc STUDENT;
select * from user_tab_columns;
SELECT * FROM USER_TABLES;
SELECT TABLE_NAME, OWNER FROM ALL_TABLES;
SELECT COLUMN_NAME, DATA_TYPE FROM USER_TAB_COLUMNS WHERE TABLE_NAME='STUDENT';

-- SLIDE 13/14 -----------------------------------------------------------------
--select * from sys.all_tab_columns;
comment on table Student IS 'Testovaci komentar';
comment on column Student.prijmeni IS 'Testovaci komentar';

COMMENT ON TABLE student IS 'Tabulka obsahuje zaznamy o studentech bakalarskeho,
  magisterskeho a doktorskeho studia';
COMMENT ON COLUMN student.fname IS 'Jmno studenta';

SELECT * FROM USER_TAB_COMMENTS;
SELECT * FROM USER_COL_COMMENTS;

SELECT * FROM USER_TAB_PRIVS;

SELECT * FROM ALL_TAB_PRIVS;

--select comments for 

-- SLIDE 14/14 -----------------------------------------------------------------
SELECT * FROM table_privileges WHERE GRANTOR = 'SYS';