-- SLIDE 2/10 ------------------------------------------------------------------
CREATE TABLE Student (
  login CHAR(6) PRIMARY KEY,
  fname VARCHAR(30) NOT NULL,
  lname VARCHAR(50) NOT NULL,
  email VARCHAR(50) NOT NULL);
  
-- SLIDE 3/10 ------------------------------------------------------------------
ALTER TABLE Student ADD tallness INT NOT NULL;
ALTER TABLE Student MODIFY email VARCHAR(30) NULL;

BEGIN
  INSERT INTO Student (login, fname, lname, tallness)
  VALUES ('buh05', 'Jan', 'Buhda', 175);
END;

-- SLIDE 4/10 ------------------------------------------------------------------
EXECUTE dbms_output.put_line('test');

-- SLIDE 5/10 ------------------------------------------------------------------
SET AUTOCOMMIT ON;

-- SLIDE 6/10 ------------------------------------------------------------------
DECLARE
  v_login CHAR(6);
  v_fname VARCHAR(30);
  v_lname VARCHAR(50);
  v_tallness INT;
BEGIN
  v_login := 'buh05';
  v_fname := 'Jan';
  v_lname := 'Buhda';
  v_tallness := 175;
  
  dbms_output.put_line('Student: ' || v_fname || ' ' || v_lname);
END;

DECLARE
  v_login STUDENT.LOGIN%TYPE;
  v_fname STUDENT.FNAME%TYPE;
  v_lname STUDENT.LNAME%TYPE;
  v_tallness STUDENT.TALLNESS%TYPE;
BEGIN
  v_login := 'buh05';
  v_fname := 'Jan';
  v_lname := 'Buhda';
  v_tallness := 175;
  
  dbms_output.put_line('Student: ' || v_fname || ' ' || v_lname);
END;

DECLARE
  v_s STUDENT%ROWTYPE;
BEGIN
  SELECT * INTO v_s FROM STUDENT WHERE login = 'buh05';
  dbms_output.put_line('Student: ' || v_s.fname || ' ' || v_s.lname);
END;

-- SLIDE 7/10 ------------------------------------------------------------------
DELETE FROM Student;

BEGIN
  INSERT INTO Student (login, fname, lname, tallness)
  VALUES ('abc123', 'Abec', 'Eded', 456);
  
  INSERT INTO Student (login, fname, lname, tallness)
  VALUES ('bce145', 'Bce', 'Qwery', 458);
  
  COMMIT;
  dbms_output.put_line('ok');
EXCEPTION
  WHEN OTHERS THEN
    dbms_output.put_line('error');
    ROLLBACK;
END;

-- test na Autocommit
DELETE FROM Student;
COMMIT;
INSERT INTO Student (login, fname, lname, tallness)
VALUES ('abc123', 'Abec', 'Eded', 456);
INSERT INTO Student (login, fname, lname, tallness)
VALUES ('bce145', 'Bce', 'Qwery', 458);
ROLLBACK;
SELECT * FROM Student;

SET AUTOCOMMIT OFF;

-- SLIDE 8/10 ------------------------------------------------------------------
CREATE OR REPLACE PROCEDURE AddStudent (p_login VARCHAR, p_fname VARCHAR, p_lname
  VARCHAR, p_tallness INT) AS
BEGIN
  INSERT INTO Student (login, fname, lname, tallness)
  VALUES (p_login, p_fname, p_lname, p_tallness);
END;

EXECUTE AddStudent('iop456', 'Karel', 'Pytel', 455);

CREATE OR REPLACE FUNCTION FAddStudent(p_login VARCHAR, p_fname VARCHAR, p_lname
  VARCHAR, p_tallness INT) RETURN VARCHAR AS
BEGIN
  INSERT INTO Student (login, fname, lname, tallness)
  VALUES (p_login, p_fname, p_lname, p_tallness);
  RETURN 'ok';
EXCEPTION
  WHEN OTHERS THEN
    RETURN 'error';
END;

EXECUTE dbms_output.put_line(FAddStudent('iop457', 'Karel', 'Pytel', 455));

-- SLIDE 10/10 -----------------------------------------------------------------
CREATE OR REPLACE PROCEDURE StudentBecomeTeacher(p_login VARCHAR,
  p_department INT) AS
s STUDENT%ROWTYPE;
BEGIN
  SELECT * INTO s FROM STUDENT WHERE login = p_login;
  DELETE FROM STUDENT WHERE login = p_login;
  INSERT INTO TEACHER (login, fname, lname, department)
  VALUES (s.login, s.fname, s.lname, p_department);
  COMMIT;
EXCEPTION
  WHEN OTHERS THEN
    ROLLBACK;
END;


