-- SLIDE 2/10 ------------------------------------------------------------------
DECLARE
  TYPE t_rc IS REF CURSOR;
  r_c t_rc;
  v_dummy all_objects.object_name%type;
  v_start NUMBER;
  v_end NUMBER;
BEGIN
  v_start := dbms_utility.get_time;
  FOR i IN 1 .. 1000
  LOOP
    OPEN r_c FOR 'SELECT object_name FROM all_objects WHERE object_id = ' || i;
    FETCH r_c INTO v_dummy;
    --dbms_output.put_line(i || ': ' || v_dummy);
    CLOSE r_c;
  END LOOP;
  v_end := dbms_utility.get_time;
  dbms_output.put_line(round((v_end - v_start)/100, 2) || ' s');
END;

DECLARE
  TYPE t_rc IS REF CURSOR;
  r_c t_rc;
  v_dummy all_objects.object_name%type;
  v_start NUMBER;
  v_end NUMBER;
BEGIN
  v_start := dbms_utility.get_time;
  FOR i IN 1 .. 1000
  LOOP
    OPEN r_c FOR 'SELECT object_name FROM all_objects WHERE object_id = :x' USING i;
    FETCH r_c INTO v_dummy;
    --dbms_output.put_line(i || ': ' || v_dummy);
    CLOSE r_c;
  END LOOP;
  v_end := dbms_utility.get_time;
  dbms_output.put_line(round((v_end - v_start)/100, 2) || ' s');
END;

-- SLIDE 3/10 ------------------------------------------------------------------
CREATE TABLE Usertab(
  ID NUMBER PRIMARY KEY,
  fname VARCHAR(50) NOT NULL,
  lname VARCHAR(50) NOT NULL);
  
CREATE OR REPLACE PROCEDURE InsertInUsertab AS
  v_str VARCHAR(100);
BEGIN
  FOR v_i IN 1 .. 10000 LOOP
    v_str := 'INSERT INTO UserTab (ID, fname, lname) VALUES (' || v_i ||
      ', ''fname' || v_i || ''', ''lname' || v_i || ''')';
    EXECUTE IMMEDIATE v_str;
  END LOOP;
END;
  
CREATE OR REPLACE PROCEDURE InsertInUsertab2 AS
  v_str VARCHAR(100);
BEGIN
  FOR v_i IN 1 .. 10000 LOOP
    v_str := 'INSERT INTO UserTab (ID, fname, lname) VALUES (:x, :y, :z)';
    EXECUTE IMMEDIATE v_str USING v_i, 'fname'||v_i, 'lname'||v_i;
  END LOOP;
END;

DECLARE
  v_start NUMBER;
  v_end NUMBER;
BEGIN
  DELETE FROM UserTab;
  v_start := dbms_utility.get_time;
  InsertInUsertab2;
  v_end := dbms_utility.get_time;
  dbms_output.put_line(round((v_end - v_start)/100, 2) || ' s');
END;

-- SLIDE 4/10 ------------------------------------------------------------------
--SET AUTOCOMMIT ON;

CREATE OR REPLACE PROCEDURE InsertInUsertab3 AS
  v_str VARCHAR(100);
BEGIN
  FOR v_i IN 1 .. 100000 LOOP
    v_str := 'INSERT INTO UserTab (ID, fname, lname) VALUES (:x, :y, :z)';
    EXECUTE IMMEDIATE v_str USING v_i, 'fname'||v_i, 'lname'||v_i;
    COMMIT;
  END LOOP;
END;

CREATE OR REPLACE PROCEDURE InsertInUsertab4 AS
  v_str VARCHAR(100);
BEGIN
  FOR v_i IN 1 .. 100000 LOOP
    v_str := 'INSERT INTO UserTab (ID, fname, lname) VALUES (:x, :y, :z)';
    EXECUTE IMMEDIATE v_str USING v_i, 'fname'||v_i, 'lname'||v_i;
  END LOOP;
  COMMIT;
END;

DECLARE
  v_start NUMBER;
  v_end NUMBER;
BEGIN
  DELETE FROM UserTab;
  v_start := dbms_utility.get_time;
  InsertInUsertab4;
  v_end := dbms_utility.get_time;
  dbms_output.put_line(round((v_end - v_start)/100, 2) || ' s');
END;
  
-- SLIDE 5/10 ------------------------------------------------------------------

CREATE OR REPLACE PROCEDURE InsertInUsertab5 AS
  TYPE t_array IS VARRAY(100000) OF UserTab%ROWTYPE;
  v_userArray t_array;
BEGIN
  v_userArray := t_array();
  v_userArray.EXTEND(100000);
  
  FOR v_i IN 1..100000 LOOP
    v_userArray(v_i).id := v_i;
    v_userArray(v_i).fname := 'fname' || v_i;
    v_userArray(v_i).lname := 'lname' || v_i;
  END LOOP;
  
  FORALL i IN v_userArray.FIRST..v_userArray.LAST
  INSERT INTO UserTab VALUES v_userArray(i);
END;

-- SLIDE 6/10 ------------------------------------------------------------------

CREATE TABLE Department
(
  id NUMBER PRIMARY KEY,
  name VARCHAR(50) NOT NULL,
  head CHAR(6) NULL
);

CREATE TABLE Teacher
(
  login CHAR(6) PRIMARY KEY,
  fname VARCHAR(30) NOT NULL,
  lname VARCHAR(50) NOT NULL,
  email VARCHAR(50) NOT NULL,
  department NUMBER NOT NULL,
  FOREIGN KEY (department) REFERENCES Department(id)  
);

ALTER TABLE Department
ADD FOREIGN KEY (head) REFERENCES Teacher(login);

-- SLIDE 7/10 ------------------------------------------------------------------

CREATE SEQUENCE seq_department START WITH 1 INCREMENT BY 1;

INSERT INTO Department(id, name) VALUES (seq_department.nextval, 'Katedra informatiky');
INSERT INTO Department(id, name) VALUES (seq_department.nextval, 'Katedra elektroenegetiky');
INSERT INTO Department(id, name) VALUES (seq_department.nextval, 'Katedra kybernetiky');

INSERT INTO Teacher(login, fname, lname, email, department) VALUES ('luk194', 'Petr', 'Lukas', 'petr.lukas@vsb.cz', 6);
INSERT INTO Teacher(login, fname, lname, email, department) VALUES ('hof078', 'Hiri', 'Hofrichter', 'jiri.hofrichter@vsb.cz', 7);
INSERT INTO Teacher(login, fname, lname, email, department) VALUES ('nie074', 'Lukas', 'Niederle', 'lukas.niederle@vsb.cz', 8);
INSERT INTO Teacher(login, fname, lname, email, department) VALUES ('mig007', 'Marketa', 'Migdalova', 'marketa.migdalova@vsb.cz', 6);

UPDATE Department SET head = 'luk194' WHERE Id = 6;
UPDATE Department SET head = 'hof078' WHERE Id = 7;
UPDATE Department SET head = 'nie074' WHERE Id = 8;

CREATE OR REPLACE TRIGGER tg_insert_department BEFORE INSERT ON department FOR EACH ROW
DECLARE
BEGIN
  SELECT seq_department.nextval INTO :new.id FROM dual;
END;

-- SLIDE 8/10 ------------------------------------------------------------------
DECLARE
  counter INT := 0;
BEGIN
  COMMIT;
  SET TRANSACTION READ ONLY;
  
  FOR depart_row IN (SELECT d.* FROM Department d)
  LOOP
    SELECT count(*) INTO counter FROM Teacher WHERE TEACHER.DEPARTMENT=depart_row.id;
    
    dbms_output.put_line('Nazev katery:      ' || depart_row.name);
    dbms_output.put_line('Pocet zamestnancu: ' || counter);
    dbms_output.put_line('Zamestnanci:');
    
    FOR teacher_row IN (SELECT * FROM Teacher WHERE department=depart_row.id AND login != depart_row.head)
    LOOP
      dbms_output.put_line(teacher_row.fname || ' ' || teacher_row.lname || ' (' || teacher_row.email || ')') ;
    END LOOP;
    dbms_output.put_line('---------------------------------------------------');
  END LOOP;
  COMMIT;
END;

-- SLIDE 9/10 ------------------------------------------------------------------

CREATE VIEW Teacher6 AS
SELECT * FROM Teacher WHERE Department = 6;

CREATE VIEW DepartmentList AS
SELECT
  department.id AS department, department.name, COUNT(teacher.login) AS employees
FROM
  department
  LEFT JOIN teacher ON department.id = teacher.department
GROUP BY
  department.id, department.name;

CREATE VIEW Teachersimply AS
SELECT login, fname, lname
FROM teacher;